/* yasep/gui-js/webring.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
 created mer. mai  2 11:19:43 CEST 2012

 This creates a window and imports a list of websites from an external .js file
 */

init_obj.push(webring={
  win: null,
  loaded:0,

  fill_window: function() {
    if (typeof sites != "object" && webring.loaded++<200) {
      webring.cont.innerHTML+=" .";
      setTimeout(webring.fill_window,100);
      return;
    }

    var i,j,h;

    if (typeof sites!="object")
      h=I8N("wrf");
    else {
      h=I8N("wr");

      for (i in sites) {
        j=sites[i];
        if (j && j.indexOf("yasep")==-1)
          h+='<a target="_blank" href="'+j+'">'+j+'</a>\n';
      }
    }
    webring.cont.innerHTML=h+'</pre>';

  },

  start: function() {
    if (webring.loaded==0) // incremented later so the code is loaded only once
      import_code("http://members.iinet.net.au/~daveb/simplex/webring.js",  function(){webring.loaded+=300} ); // Load the script
    (webring.cont=dcE("DIV")).innerHTML="loading";
    webring.fill_window();
    webring.win = ygwm.new_window(
       "Webring", null, webring.cont,
       450, 300, 30, 40, false, true, true, true, false,  "doc_vibu");
    return webring.win;
  },

  init_obj: function(){
    webring.menuItem=menu.subMenuItem(menu.list["Web"],["WebRing"], "webring");
  }
});
